#version 120

uniform vec4 round;
uniform vec4 pos;
uniform vec2 size;
uniform sampler2D texture;
uniform float alpha;
uniform float hurtPercent;

float roundSDF(vec2 p, vec2 b, vec4 r) {
    vec2 q = abs(p) - b + r.xy;
    float k = max(r.x, r.y);
    return min(max(q.x, q.y), 0.0) + length(max(q, 0.0)) - k;
}

void main() {
    vec2 p = gl_TexCoord[0].st * size - size / 2.0;

    vec2 position = gl_TexCoord[0].st;

    position.x = pos.x + position.x * pos.z;
    position.y = pos.y + position.y * pos.w;

    float sdf = roundSDF(p, size / 2.0, round);

    float antialias = 1.0;

    float alphaSmooth = smoothstep(0.0, antialias, -sdf);

    vec4 color = texture2D(texture, position);
    color.rgb = mix(color.rgb, vec3(1.0, 0.0, 0.0), hurtPercent);

    gl_FragColor = vec4(color.rgb, alphaSmooth * alpha);
}